# coding: utf-8

"""
    Natural Language Understanding

    Extracts entities (e.g., people, organizations, locations) and relations/properties about these entities from natural language text   # noqa: E501

    OpenAPI spec version: 1.0.0
    Contact: jay@diffbot.com
    Generated by: https://github.com/swagger-api/swagger-codegen.git
"""


import pprint
import re  # noqa: F401

import six

from diffbot_nlapi.models.evidence import Evidence  # noqa: F401,E501
from diffbot_nlapi.models.model_property import ModelProperty  # noqa: F401,E501
from diffbot_nlapi.models.qualifier import Qualifier  # noqa: F401,E501
from diffbot_nlapi.models.statement_entity import StatementEntity  # noqa: F401,E501


class Statement(object):
    """NOTE: This class is auto generated by the swagger code generator program.

    Do not edit the class manually.
    """

    """
    Attributes:
      swagger_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    """
    swagger_types = {
        'human_readable': 'str',
        'entity': 'StatementEntity',
        '_property': 'ModelProperty',
        'value': 'StatementEntity',
        'qualifiers': 'list[Qualifier]',
        'confidence': 'float',
        'evidence': 'list[Evidence]'
    }

    attribute_map = {
        'human_readable': 'humanReadable',
        'entity': 'entity',
        '_property': 'property',
        'value': 'value',
        'qualifiers': 'qualifiers',
        'confidence': 'confidence',
        'evidence': 'evidence'
    }

    def __init__(self, human_readable=None, entity=None, _property=None, value=None, qualifiers=None, confidence=None, evidence=None):  # noqa: E501
        """Statement - a model defined in Swagger"""  # noqa: E501

        self._human_readable = None
        self._entity = None
        self.__property = None
        self._value = None
        self._qualifiers = None
        self._confidence = None
        self._evidence = None
        self.discriminator = None

        if human_readable is not None:
            self.human_readable = human_readable
        if entity is not None:
            self.entity = entity
        if _property is not None:
            self._property = _property
        if value is not None:
            self.value = value
        if qualifiers is not None:
            self.qualifiers = qualifiers
        if confidence is not None:
            self.confidence = confidence
        if evidence is not None:
            self.evidence = evidence

    @property
    def human_readable(self):
        """Gets the human_readable of this Statement.  # noqa: E501


        :return: The human_readable of this Statement.  # noqa: E501
        :rtype: str
        """
        return self._human_readable

    @human_readable.setter
    def human_readable(self, human_readable):
        """Sets the human_readable of this Statement.


        :param human_readable: The human_readable of this Statement.  # noqa: E501
        :type: str
        """

        self._human_readable = human_readable

    @property
    def entity(self):
        """Gets the entity of this Statement.  # noqa: E501


        :return: The entity of this Statement.  # noqa: E501
        :rtype: StatementEntity
        """
        return self._entity

    @entity.setter
    def entity(self, entity):
        """Sets the entity of this Statement.


        :param entity: The entity of this Statement.  # noqa: E501
        :type: StatementEntity
        """

        self._entity = entity

    @property
    def _property(self):
        """Gets the _property of this Statement.  # noqa: E501


        :return: The _property of this Statement.  # noqa: E501
        :rtype: ModelProperty
        """
        return self.__property

    @_property.setter
    def _property(self, _property):
        """Sets the _property of this Statement.


        :param _property: The _property of this Statement.  # noqa: E501
        :type: ModelProperty
        """

        self.__property = _property

    @property
    def value(self):
        """Gets the value of this Statement.  # noqa: E501


        :return: The value of this Statement.  # noqa: E501
        :rtype: StatementEntity
        """
        return self._value

    @value.setter
    def value(self, value):
        """Sets the value of this Statement.


        :param value: The value of this Statement.  # noqa: E501
        :type: StatementEntity
        """

        self._value = value

    @property
    def qualifiers(self):
        """Gets the qualifiers of this Statement.  # noqa: E501


        :return: The qualifiers of this Statement.  # noqa: E501
        :rtype: list[Qualifier]
        """
        return self._qualifiers

    @qualifiers.setter
    def qualifiers(self, qualifiers):
        """Sets the qualifiers of this Statement.


        :param qualifiers: The qualifiers of this Statement.  # noqa: E501
        :type: list[Qualifier]
        """

        self._qualifiers = qualifiers

    @property
    def confidence(self):
        """Gets the confidence of this Statement.  # noqa: E501


        :return: The confidence of this Statement.  # noqa: E501
        :rtype: float
        """
        return self._confidence

    @confidence.setter
    def confidence(self, confidence):
        """Sets the confidence of this Statement.


        :param confidence: The confidence of this Statement.  # noqa: E501
        :type: float
        """

        self._confidence = confidence

    @property
    def evidence(self):
        """Gets the evidence of this Statement.  # noqa: E501


        :return: The evidence of this Statement.  # noqa: E501
        :rtype: list[Evidence]
        """
        return self._evidence

    @evidence.setter
    def evidence(self, evidence):
        """Sets the evidence of this Statement.


        :param evidence: The evidence of this Statement.  # noqa: E501
        :type: list[Evidence]
        """

        self._evidence = evidence

    def to_dict(self):
        """Returns the model properties as a dict"""
        result = {}

        for attr, _ in six.iteritems(self.swagger_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value
        if issubclass(Statement, dict):
            for key, value in self.items():
                result[key] = value

        return result

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self.to_dict())

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, Statement):
            return False

        return self.__dict__ == other.__dict__

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        return not self == other
